Commits

Benjamin Peterson committed 013d4d8

apply a fix for #3611 where the current exception context was deleted with a generator causing a segfault

  • Participants
  • Parent commits 033d63b

Comments (0)

Files changed (2)

Lib/test/test_exceptions.py

             pass
         self.assertEquals(e, (None, None, None))
 
+    def test_3118(self):
+        def gen():
+            try:
+                yield 1
+            finally:
+                pass
+
+        def f():
+            g = gen()
+            next(g)
+            try:
+                try:
+                    raise ValueError
+                except:
+                    del g
+                    raise KeyError
+            except Exception as e:
+                self.assert_(isinstance(e.__context__, ValueError))
+
+        f()
+
+
     def test_badisinstance(self):
         # Bug #2542: if issubclass(e, MyException) raises an exception,
         # it should be ignored
 
 			if (b->b_type == EXCEPT_HANDLER) {
 				UNWIND_EXCEPT_HANDLER(b);
-				if (why == WHY_EXCEPTION) {
+				if (why == WHY_EXCEPTION && !throwflag) {
 					Py_CLEAR(tstate->exc_type);
 					Py_CLEAR(tstate->exc_value);
 					Py_CLEAR(tstate->exc_traceback);